/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package nl.jhhcvandermeijs.tcpconns1.testsuite;

import java.io.IOException;
import java.security.cert.X509Certificate;
import nl.jhhcvandermeijs.tcpconns.server.TServerSideProtocol;
import nl.jhhcvandermeijs.tcpconns.client.TTCPConnection;
import nl.jhhcvandermeijs.tcpconns.keys.KeyStoreHelper;
import nl.jhhcvandermeijs.tcpconns.server.TTCPServer;

/**
 *
 * @author anonymous
 */
public class MyServerSideProtocol extends TServerSideProtocol {
    public MyServerSideProtocol(TTCPConnection aTTCPConnection, TTCPServer aTTCPServer) {
        super(aTTCPConnection, aTTCPServer);
    }
    
    @Override
    public void processRequest() throws IOException {
        int a = this.conn().in().readInt();
        this.conn().out().writeInt(a);
        this.conn().out().flush();
                
        try {
            this.conn().makeSecureWithClientCertAuthByServer(((MyTCPServer)(this.fTTCPServer)).fKeyManagers);
        } catch (Exception e) {
            throw new IOException();
        }
        
        java.security.cert.Certificate[] peerCertChain = this.conn().getPeerCertificateChain();        
        //check whether we have a peerCertChain
        if (peerCertChain == null) {
            this.conn().disconnect();
            return;         
        }
        //check whether the peerCertChain contains certs
        if (peerCertChain.length == 0) {        
            this.conn().disconnect();
            return;
        }
        
        if (!(peerCertChain[0] instanceof X509Certificate)) {
            this.conn().disconnect();
            return; 
        }
                
        if (KeyStoreHelper.isValid(((X509Certificate)(peerCertChain[0])), ((MyTCPServer)(this.fTTCPServer)).fTrustedCA)) {
            //cert is valid: check for revocation status here
            //System.out.println("CERT IS VALID");
        } else {
            //System.out.println("CERT IS *IN*VALID");
            this.conn().disconnect();
            return;
        }
                        
        a = this.conn().in().readInt();
        this.conn().out().writeInt(a);
        this.conn().out().flush();

        this.conn().makeInsecure();
        
        a = this.conn().in().readInt();
        this.conn().out().writeInt(a);
        this.conn().out().flush();        
        
        this.conn().disconnect();
        return;
    } 
}
